unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, process, FileUtil, Forms, Controls, Graphics, Dialogs,
  ComCtrls, StdCtrls, CheckLst, Buttons, ExtCtrls, AsyncProcess, types;

type

  { TForm1 }

  TForm1 = class(TForm)
    AsyncProcess1: TAsyncProcess;
    btn_Unfreez: TButton;
    Button1: TButton;
    button_freeze: TButton;
    cb_Firefox: TCheckBox;
    CheckListBox1: TCheckListBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    gb_Log: TGroupBox;
    ListBox_home: TListBox;
    Memo1: TMemo;
    Memo2: TMemo;
    Process1: TProcess;
    SpeedButton1: TSpeedButton;
    procedure AsyncProcess1ReadData(Sender: TObject);
    procedure btn_UnfreezClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure button_freezeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox_homeDrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure ListBox_homeSelectionChange(Sender: TObject; User: boolean);
    procedure CheckHomeAndFreez;
    procedure SpeedButton1Click(Sender: TObject);
  private
    x: integer;
    name_sesion_file: string;
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }
  uses Unit2;

procedure TForm1.CheckHomeAndFreez;
var
  searchResult:TSearchRec;
begin
 ListBox_home.Clear;
 x:=0;
 //Создаем список хомячных папок
 if FindFirst('/home/*',faDirectory,searchResult)= 0
  then
  begin
      repeat
        if ((searchResult.attr and faDirectory) = faDirectory) and (searchResult.Name<> '..') and (searchResult.Name<> '.') and (searchResult.Name<> 'lost+found')
            then
            begin
                ListBox_home.Items.Add(searchResult.Name);
                if DirectoryExists('/home/.freez/'+searchResult.Name) = true then
                   begin
                   ListBox_home.Items.Delete(ListBox_home.Items.IndexOf(searchResult.Name));
                   ListBox_home.Items.AddObject(searchResult.Name,TObject(1));
                   inc(x);
                   end;
            end;
      until FindNext(searchResult)<>0;
      FindClose(searchResult);
  end;
   cb_Firefox.Checked:=False;
 end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.button_freezeClick(Sender: TObject);
var
n: Integer;
exclude: String;
tfile: TStringList;
script: TextFile;
begin
 button_freeze.Enabled:=False;
 ListBox_home.Enabled:=False;
 CheckListBox1.Enabled:=False;
 exclude:='';
 for n := 0 to CheckListBox1.Items.Count - 1 do
  begin
    if CheckListBox1.Checked[n]= true then
       exclude:= exclude + '--exclude "'+ CheckListBox1.Items[n] +'" ';
  end;
 if  cb_Firefox.Checked=True then exclude:=exclude + '--exclude ".mozilla" ';
 if x = 0 then
    begin
       tfile:= TStringList.Create; // создание списка строк
       tfile.LoadFromFile('/etc/pam.d/'+name_sesion_file);
       if tfile.IndexOf('session optional pam_exec.so seteuid /etc/security/pam_exec') = -1 then  //доп. проверка если запись уже вставлена
        begin
          tfile.Add('session optional pam_exec.so seteuid /etc/security/pam_exec');  // Прописываем загрузчик
          tfile.SaveToFile('/etc/pam.d/'+name_sesion_file); //Записываем
        end;
       tfile.Free;

       // Создаем скрипт в  /etc/security/pam_exeс
       if not FileExists('/etc/security/pam_exec') then    //доп. проверка если файл уже сущестует
        begin
          AssignFile(script,'/etc/security/pam_exec');
          Rewrite(script);
          Writeln(script, '#!/bin/bash');
          Writeln(script, 'case $PAM_TYPE in');
          Writeln(script, '   open_session)');
          Writeln(script, '                   run-parts /etc/pam_exec/login_scripts/');
          Writeln(script, '               ;;');
          Writeln(script, '   close_session)');
          Writeln(script, '                   run-parts /etc/pam_exec/logout_scripts/');
          Writeln(script, '               ;;');
          Writeln(script, 'esac');
          CloseFile(script);
          Process1.CommandLine:='chmod 700 /etc/security/pam_exec';
          Process1.Options:=[poWaitOnExit];
          Process1.Execute;
         end;
       //Создаем скрипт на востановление
       createdir('/etc/pam_exec');
       createdir('/etc/pam_exec/login_scripts');
       createdir('/etc/pam_exec/logout_scripts');
       if not FileExists('/etc/pam_exec/login_scripts/00-restore') then //доп. проверка если файл уже сущестует
        begin
          AssignFile(script,'/etc/pam_exec/login_scripts/00-restore');
          Rewrite(script);
          Writeln(script, '#!/bin/bash');
          CloseFile(script);
        end;
 end;
AssignFile(script,'/etc/pam_exec/login_scripts/00-restore');
Append(script);
Writeln(script, 'if [ $PAM_USER == "'+ListBox_home.Items[ListBox_home.ItemIndex]+'" ] ;');
Writeln(script, '  then rsync -a --delete --exclude ".strigi" '+exclude+'/home/.freez/$PAM_USER/ /home/$PAM_USER/');
Writeln(script, '  chown $PAM_USER:$PAM_USER -R /home/$PAM_USER');
Writeln(script, 'fi');
CloseFile(script);

Process1.CommandLine:='chmod 700 /etc/pam_exec/login_scripts/00-restore';
Process1.Options:=[poWaitOnExit];
Process1.Execute;
createdir('/home/.freez');

//Первоночальный бекап
AsyncProcess1.CommandLine:='rsync -a --delete --progress --exclude ".strigi" '+exclude+'/home/'+ListBox_home.Items[ListBox_home.ItemIndex]+'/ /home/.freez/'+ListBox_home.Items[ListBox_home.ItemIndex];
AsyncProcess1.Options:=[poUsePipes, poStderrToOutPut];
AsyncProcess1.ShowWindow:=swoHIDE;
AsyncProcess1.Execute;
end;

procedure TForm1.btn_UnfreezClick(Sender: TObject);
var
tfile: TStringList;
StartDelIndex: Integer;
begin
 StartDelIndex:=0;
if x<=1 then
  begin
     tfile:= TStringList.Create; // создание списка строк
     tfile.LoadFromFile('/etc/pam.d/'+name_sesion_file);
     if tfile.IndexOf('session optional pam_exec.so seteuid /etc/security/pam_exec') <> -1 then
       begin
         tfile.Delete(tfile.IndexOf('session optional pam_exec.so seteuid /etc/security/pam_exec'));
         tfile.SaveToFile('/etc/pam.d/'+name_sesion_file); //Записываем
       end;
     tfile.Free;
     Process1.CommandLine:='rm -r /etc/pam_exec';
     Process1.Options:=[poWaitOnExit];
     Process1.Execute;
     DeleteFile('/etc/security/pam_exec');
  end
 else
    begin
      tfile:= TStringList.Create;
      tfile.LoadFromFile('/etc/pam_exec/login_scripts/00-restore');
      StartDelIndex:=tfile.IndexOf('if [ $PAM_USER == "'+ListBox_home.Items[ListBox_home.ItemIndex]+'" ] ;');
      tfile.Delete(StartDelIndex+3);
      tfile.Delete(StartDelIndex+2);
      tfile.Delete(StartDelIndex+1);
      tfile.Delete(StartDelIndex);
      tfile.SaveToFile('/etc/pam_exec/login_scripts/00-restore');
      tfile.Free;
    end;
Process1.CommandLine:='rm -r /home/.freez/'+ListBox_home.Items[ListBox_home.ItemIndex];
Process1.Options:=[poWaitOnExit];
Process1.Execute;
CheckHomeAndFreez;
ShowMessage('Разморозка успешно выполнена');
Memo2.Text:='Разморозка успешно выполнена';
end;

procedure TForm1.AsyncProcess1ReadData(Sender: TObject);
var
     s:String;
     b:DWord;
begin
   s:='';
   b:=AsyncProcess1.NumBytesAvailable;
   if b>0 then
   begin
     setlength(s, b);
     AsyncProcess1.Output.Read(s[1], b);
     if s=' ' then
     begin
       exit;
     end;
     Memo2.Lines.Add(s);
     Memo2.SetFocus;
     Memo2.SelStart :=Length(Memo2.Text);
     Memo2.SelLength:=0;
   end;
   if Pos('total size is', s ) <> 0 then
   begin
     AsyncProcess1.Free;
     Process1.CommandLine:='chown root:root -R /home/.freez/'+ListBox_home.Items[ListBox_home.ItemIndex];
     Process1.Options:=[poWaitOnExit];
     Process1.Execute;
     CheckHomeAndFreez;
     ShowMessage('Заморозка успешно выполнена');
     button_freeze.Enabled:=True;
     ListBox_home.Enabled:=True;
     CheckListBox1.Enabled:=True;
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  chroot: TStringList;
begin
 if FileExists('/etc/pam.d/system-auth') = True then name_sesion_file:='system-auth'  //АлтЛинукс, Mandriva
   else
    begin
       if FileExists('/etc/pam.d/common-session') = True then name_sesion_file:='common-session'   //Ubuntu
          else
            begin
              ShowMessage('Версия ОС не определена. Заморозка не возможна');
              exit;
            end;
    end;
 chroot:= TStringList.Create; // создание списка строк
 try
 chroot.SaveToFile('/etc/test');
 except
    on E : Exception do
    begin
      ShowMessage('Попытка запуска программы не с root-правами.');
      halt;
    end;
  end;
 DeleteFile('/etc/test');
 chroot.Free;
 CheckHomeAndFreez;
end;

procedure TForm1.ListBox_homeDrawItem(Control: TWinControl; Index: Integer;
  ARect: TRect; State: TOwnerDrawState);
begin
 with (Control as TListBox).Canvas do
 begin
     if Integer(ListBox_home.Items.Objects[Index]) = 1 then
      begin
        Font.Color := clBlue;
        Font.Style:=Font.Style+[fsBold];
      end;
   FillRect(ARect);
   TextOut(ARect.Left, ARect.Top, (Control as TListBox).Items[Index]);
  end;
end;

procedure TForm1.ListBox_homeSelectionChange(Sender: TObject; User: boolean);
var
  searchResult:TSearchRec;
begin
  CheckListBox1.Clear;
 if FindFirst('/home/'+ListBox_home.Items[ListBox_home.ItemIndex]+'/*',faDirectory,searchResult)= 0
  then
  begin
      repeat
        if ((searchResult.attr and faDirectory) = faDirectory) and (searchResult.Name<> '..') and (searchResult.Name<> '.')
            then  CheckListBox1.Items.Add(searchResult.Name);
      until FindNext(searchResult)<>0;
      FindClose(searchResult);
 end;
 if Integer(ListBox_home.Items.Objects[ListBox_home.ItemIndex]) = 1
     then
      begin
          button_freeze.Enabled:=False;
          btn_Unfreez.Enabled:=True;
          CheckListBox1.Enabled:=False;
      end
     else
       begin
        button_freeze.Enabled:=True;
        btn_Unfreez.Enabled:=False;
        CheckListBox1.Enabled:=True;
       end;
 end;


end.
